from datetime import datetime, timedelta
from time import sleep
import pytz
import json
import requests
import sys

def sortevents(leaguedata, league):

    games = []
    haslive = False

    for event in leaguedata['events']:

        event_desc = event['status']['type']['shortDetail']  # use this to display time and quarter on ticker
        event_date = event['date'].split('T')[0]
        event_liveOrNot = event['status']['type']['state'] # use this to determine if game has ended or not
        if event_liveOrNot == 'in':
            haslive = True
        has_live = 'has_live'
        no_upcoming = 'no_upcoming'

        for home_away in event['competitions']:
            for home_away2 in home_away['competitors']:
                if home_away2['homeAway'] == 'away':
                    if home_away2['team']['displayName'] == 'Washington Commanders':
                        away_team = 'Washington'
                    else:
                        away_team = home_away2['team']['displayName']
                    away_score = home_away2['score']
                else:
                    if home_away2['team']['displayName'] == 'Washington Commanders':
                        home_team = 'Washington'
                    else:
                        home_team = home_away2['team']['displayName']
                    home_score = home_away2['score']

        if datetime.now(pytz.utc).strftime("%Y-%m-%d") == event['date'].split('T')[0] or event['date'].split('T')[0] <= (datetime.strptime(datetime.now(pytz.utc).strftime("%Y-%m-%dT%H:%MZ"), "%Y-%m-%dT%H:%MZ") + timedelta(days=1)).strftime("%Y-%m-%dT%H:%MZ").split('T')[0]:
            games.append({
                'home_team': home_team,
                'home_score': home_score,
                'away_team': away_team,
                'away_score': away_score,
                'time': event_desc,
                'date': event_date,
                'isLive': event_liveOrNot
            })
    return games, haslive, has_live, no_upcoming


f = open('csv/live_mlb.json', 'r')
all_settings = json.load(f)
f.close()

mlb_url = "https://site.api.espn.com/apis/site/v2/sports/baseball/mlb/scoreboard"

time_now = datetime.now(pytz.utc)
time_now2 = time_now.strftime("%Y-%m-%dT%H:%MZ")

mlb_live_now = False
mlb_games_today = False
mlb_events = []
mlb_fifteenmin = False
games_happened = False

try:
    mlb_response = requests.get(mlb_url)
    mlb_data = mlb_response.json()
except:
    sleep(120)
    mlb_response = requests.get(mlb_url)
    mlb_data = mlb_response.json()

for event in mlb_data['events']:
    if event['status']['type']['state'] == 'in':
        mlb_live_now = True
    if time_now2.split('T')[0] <= event['date'].split('T')[0] and event['date'].split('T')[0] <= (datetime.strptime(time_now2, "%Y-%m-%dT%H:%MZ") + timedelta(days=1)).strftime("%Y-%m-%dT%H:%MZ").split('T')[0]:
        mlb_events.append(event['date'])
        mlb_games_today = True
        if mlb_live_now is False and ((datetime.strptime(event['date'], "%Y-%m-%dT%H:%MZ") + timedelta(minutes=20)).strftime("%Y-%m-%dT%H:%MZ") >= datetime.now(pytz.utc).strftime("%Y-%m-%dT%H:%MZ")) and (event['date'] <= datetime.now(pytz.utc).strftime("%Y-%m-%dT%H:%MZ")):
            mlb_fifteenmin = True


while True:
    f = open('csv/live_mlb.json', 'r')
    all_settings = json.load(f)
    f.close()

    if mlb_live_now:
        try:
            mlb_response = requests.get(mlb_url)
            mlb_data = mlb_response.json()
            mlb_sorted = sortevents(mlb_data, 'MLB')
            all_settings['leagues']['MLB'] = mlb_sorted
            games_happened = True

            if mlb_sorted[1]:
                mlb_live_now = True
            else:
                mlb_live_now = False           

            f = open('csv/live_mlb.json', 'w+')
            json.dump(all_settings, f)
            f.close()

            sleep(120)
        except:
            sleep(120)


    elif mlb_fifteenmin:
        for _ in range (10):
            try:
                mlb_response = requests.get(mlb_url)
                mlb_data = mlb_response.json()
                mlb_sorted = sortevents(mlb_data, 'MLB')
                all_settings['leagues']['MLB'] = mlb_sorted

                f = open('csv/live_mlb.json', 'w+')
                json.dump(all_settings, f)
                f.close()

                sleep(120)
            except:
                sleep(120) 

        if mlb_sorted[1]:
            mlb_live_now = True
            mlb_fifteenmin = False
            games_happened = True
        else:
            mlb_live_now = False
            mlb_fifteenmin = False

    else:
        mlb_events2 = []

        try:
            for event in mlb_events:
                if event >= datetime.now(pytz.utc).strftime("%Y-%m-%dT%H:%MZ"):
                    mlb_events2.append(event)
                    mlb_games_today = True
            next_mlb = min(mlb_events2)
            d = datetime.strptime(next_mlb, "%Y-%m-%dT%H:%MZ")
            mlb_time_left = (d - (datetime.strptime(datetime.now(pytz.utc).strftime("%Y-%m-%dT%H:%MZ"), "%Y-%m-%dT%H:%MZ"))).total_seconds()
            all_settings['leagues']['MLB'][3] = next_mlb

            f = open('csv/live_mlb.json', 'w+')
            json.dump(all_settings, f)
            f.close()

        except:
            mlb_games_today = False
            next_mlb = []
            all_settings['leagues']['MLB'][3] = 'no_upcoming'

            f = open('csv/live_mlb.json', 'w+')
            json.dump(all_settings, f)
            f.close()
            pass    

        if mlb_games_today:
            sleep(mlb_time_left)
            mlb_fifteenmin = True


    if mlb_live_now is False and mlb_games_today is False and games_happened is True:
        sleep(7200)
        all_settings['leagues']['MLB'][2] = 'no_live'
        all_settings['leagues']['MLB'][3] = 'no_upcoming'

        f = open('csv/live_mlb.json', 'w+')
        json.dump(all_settings, f)
        f.close()  

        break


    if mlb_live_now is False and mlb_games_today is False and games_happened is False:
        all_settings['leagues']['MLB'][2] = 'no_live'
        all_settings['leagues']['MLB'][3] = 'no_upcoming'

        f = open('csv/live_mlb.json', 'w+')
        json.dump(all_settings, f)
        f.close()  

        break
